<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RelStay ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RelStay extends AbstractStructArrayBase
{
    /**
     * The RelStay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RelStay[]
     */
    public $RelStay;
    /**
     * Constructor method for ArrayOfJP_RelStay
     * @uses ArrayOfJP_RelStay::setRelStay()
     * @param \StructType\JP_RelStay[] $relStay
     */
    public function __construct(array $relStay = array())
    {
        $this
            ->setRelStay($relStay);
    }
    /**
     * Get RelStay value
     * @return \StructType\JP_RelStay[]|null
     */
    public function getRelStay()
    {
        return $this->RelStay;
    }
    /**
     * This method is responsible for validating the values passed to the setRelStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelStayForArrayConstraintsFromSetRelStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RelStayRelStayItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RelStayRelStayItem instanceof \StructType\JP_RelStay) {
                $invalidValues[] = is_object($arrayOfJP_RelStayRelStayItem) ? get_class($arrayOfJP_RelStayRelStayItem) : sprintf('%s(%s)', gettype($arrayOfJP_RelStayRelStayItem), var_export($arrayOfJP_RelStayRelStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelStay property can only contain items of type \StructType\JP_RelStay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelStay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RelStay[] $relStay
     * @return \ArrayType\ArrayOfJP_RelStay
     */
    public function setRelStay(array $relStay = array())
    {
        // validation for constraint: array
        if ('' !== ($relStayArrayErrorMessage = self::validateRelStayForArrayConstraintsFromSetRelStay($relStay))) {
            throw new \InvalidArgumentException($relStayArrayErrorMessage, __LINE__);
        }
        $this->RelStay = $relStay;
        return $this;
    }
    /**
     * Add item to RelStay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RelStay $item
     * @return \ArrayType\ArrayOfJP_RelStay
     */
    public function addToRelStay(\StructType\JP_RelStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RelStay) {
            throw new \InvalidArgumentException(sprintf('The RelStay property can only contain items of type \StructType\JP_RelStay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelStay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RelStay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RelStay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RelStay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RelStay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RelStay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelStay
     */
    public function getAttributeName()
    {
        return 'RelStay';
    }
}
